
set more off
capture log close
clear
capture clear *
set mem 7g
capture set mem 10g
qui log using "Table 2, Row 3 (movers); 2010-08-06.out", text replace
qui log close


capture program drop regrs_poes
program regrs_poes

capture log close
log using "Table 2, Row 3 (movers); `1'; 2010-08-06.out", text replace

display "`1'"

use "base interfirm 2010-08-06 mini", clear // nova versao do ficheiro principal simplificada (so variaveis fundamentais)

keep if empresa0~=empresa1
drop if  d1_`1'==.

gen s=12
replace s=24 if ano==1991 | ano==2002
replace s=19 if ano==1994
gen s2=s^2

gen s_age_newvar=s*(2*(age+1)*12-s)

ren ano year
format year %4.0f
ta year, gen(y) // mudei
ren year ano
compress
estimates clear


if `2'==3 {
	regr d1_`1' y1-y20 s_age_newvar, noconst // nova expressao, oct 2009
	est sto AA1, title("3")
	}

if `2'==3 local abc=""

matrix d1=e(b)
matrix d2=d1[1,1..20]

gen sum_ports=.
egen sum_c=count(d1_`1') if d1_`1'~=., by(ano)	// alterado
foreach z of numlist 1986/1989 1991/2000 2002/2008 {
	qui count if ano==`z' 		// & `1'1~=.
	local cnss_d`z' `r(N)'
	replace sum_ports=`cnss_d`z'' if ano==`z'
	qui sum sum_c if ano==`z' 	// & `1'1~=.
	local cnss_e`z' `r(mean)'
	display "`cnss_d`z'' `cnss_e`z''"
	}

sort ano
keep if ano~=ano[_n-1] 
gen coef_f=.
gen cnss_f=.
gen cnss_g=.

ta sum_ports

qui foreach v of numlist 1/20 {
	local z=`v'+1986
	if `v'>3 { 
		local z=`v'+1987
		}
	if `v'>13 { 
		local z=`v'+1988
		}
	replace coef_f=d2[1,`v'] if ano==`z' 
	replace cnss_f=`cnss_d`z'' if ano==`z'
	replace cnss_g=`cnss_e`z'' if ano==`z'
	}

*replace coef_f=0 if ano==1987
*replace cnss_f=`cnss_d1986' if ano==1986

keep if coef_f~=.
ren ano time

gen time_b=time // novas linhas - para trend ter em conta diferenca nos meses
replace time=(time-1981)*12
replace time=time+2 if time_b<=1993 // 1+2=3o mes do ano em 1982...
replace time=time+9 if time_b>1993

tsset time_b
gen time2=(time^2)/100
gen s_time=s*time
gen s_time2=s*time2

replace d_ur=d_ur/100
label var d_ur "Change in UR"
label var time "Trend"
label var time2 "(Trend^2)/100"

regr coef_f d_ur s  [aweight=cnss_f], noconstant 
scalar mss1=e(mss)
predict res, r
est sto A1, title("1")
estat dwatson  
scalar dw1=r(dw)

regr coef_f d_ur s s2  [aweight=cnss_f], noconstant 
scalar mss2=e(mss)
est sto A2, title("2")
estat dwatson  
scalar dw2=r(dw)

regr coef_f d_ur s s_time s2 [aweight=cnss_f], noconstant
scalar mss3=e(mss)
est sto A3, title("3")
estat dwatson  
scalar dw3=r(dw)

regr coef_f d_ur s s_time s2 s_time2 [aweight=cnss_f], noconstant
scalar mss4=e(mss)
est sto A4, title("4")
estat dwatson  
scalar dw4=r(dw)


regr coef_f d_ur s  [aweight=cnss_f] 
est sto A5, title("5")


gen inv=1/sum_ports
gen res2=res^2
regr res2 inv 		
est sto A6, title("6")

gen res2_weighted=(res*sqrt(sum_ports))^2
regr res2_weighted sum_ports 	
est sto A7, title("7")

list time ur d_ur sum_ports sum_c coef_f cnss_f cnss_g


drop res res2 inv res2_weighted

regr coef_f d_ur s, noconstant 
scalar mssC1=e(mss)
predict res, r
est sto C1, title("1")
estat dwatson  
scalar Cdw1=r(dw)

regr coef_f d_ur s s2, noconstant
scalar mssC2=e(mss)
est sto C2, title("2")
estat dwatson  
scalar Cdw2=r(dw)

regr coef_f d_ur s s_time s2, noconstant 
scalar mssC3=e(mss)
est sto C3, title("3")
estat dwatson  
scalar Cdw3=r(dw)

regr coef_f d_ur s s_time s2 s_time2, noconstant  
scalar mssC4=e(mss)
est sto C4, title("4")
estat dwatson  
scalar Cdw4=r(dw)


regr coef_f d_ur s 
est sto C5, title("5")


gen inv=1/sum_ports
gen res2=res^2
regr res2 inv 		
est sto C6, title("6")

gen res2_weighted=(res*sqrt(sum_ports))^2
regr res2_weighted sum_ports 		
est sto C7, title("7")



compress
save "Table 2, Row 3 (movers); `1'; 2010-08-06", replace
log close

qui log using "Table 2, Row 3 (movers); 2010-08-06.out", text append

if "`1'"=="mode_ln_rembaseh" local titulo "Wage (mode log base hourly wage)"
if "`1'"=="ln_rembaseh" local titulo "Wage (log mean base hourly wage)"
if "`1'"=="ln_remh" local titulo "Wage (log mean total hourly wage)"

di ""
di "*************************************************************************************"
di "*************************************************************************************"
di "*************************************************************************************"
di ""

estout AA1, cells(b(star fmt(%9.6f)) se(par([ ])) ) starlevels(* 0.10 ** 0.05 *** 0.01) stats(r2 N, fmt(%9.3f %9.0g) ///
	labels("R-squared" "No. observations")) keep(y1 y2 y3 y4 y5 y6 y7 y8 y9 y10 y11 y12 y13 y14 y15 y16 y17 y18 y19 y20 s_age_newvar) legend label varlabels(_cons Constant) varwidth(18) ///
	modelwidth(11) delimiter("") title("Table 1 - `titulo' Cyclicality - 1st stage (estimation: `abc')") collabels("" "") prehead(@title "Dependent variable: `1'")  ///
	prefoot("") postfoot("" "Notes:")

scalar dw1_t=string(dw1)
scalar dw2_t=string(dw2)
scalar dw3_t=string(dw3)
scalar dw4_t=string(dw4)
scalar dw_text = "Durbin-Watson statistics are "+ dw1_t+ ", "+dw2_t +", "+dw3_t +" and "+ dw4_t +", respectively."
scalar mss1_t=string(mss1)
scalar mss2_t=string(mss2)
scalar mss3_t=string(mss3)
scalar mss4_t=string(mss4)
scalar mss_text = "Model sum of squares statistics are "+ mss1_t+ ", "+mss2_t +", "+mss3_t +" and "+ mss4_t +", respectively."

estout A1 A2 A3 A4 A5, cells(b(star fmt(%9.4f)) se(par([ ])) ) starlevels(* 0.10 ** 0.05 *** 0.01) stats(r2 N, fmt(%9.3f %9.0g) ///
	labels("R-squared" "No. observations")) keep(d_ur s s_time s2 s_time2 _cons) legend label varlabels(_cons Constant) varwidth(18) ///
	modelwidth(11) delimiter("") title("Table 2a - `titulo' Cyclicality - 2nd stage (estimation: `abc') - weighted") collabels("" "") prehead(@title "Dependent variable: `1'" "")  ///
	prefoot("") postfoot("" "Notes:")
di dw_text
di mss_text

estout A6, cells(b(star fmt(%9.6f)) se(par([ ])) ) starlevels(* 0.10 ** 0.05 *** 0.01) stats(r2 N, fmt(%9.3f %9.0g) ///
	labels("R-squared" "No. observations")) keep(inv _cons) legend label varlabels(_cons Constant) varwidth(18) ///
	modelwidth(11) delimiter("") title("Table 2b - Heteroskedasticity test 1 - unweighted") collabels("" "") prehead(@title "Dependent variable: Squared residuals from 2nd stage regression" "")  ///
	prefoot("") postfoot("" "Notes:")

estout A7, cells(b(star fmt(%9.6f)) se(par([ ])) ) starlevels(* 0.10 ** 0.05 *** 0.01) stats(r2 N, fmt(%9.3f %9.0g) ///
	labels("R-squared" "No. observations")) keep(sum_ports _cons) legend label varlabels(_cons Constant) varwidth(18) ///
	modelwidth(11) delimiter("") title("Table 2c - Heteroskedasticity test 2 - unweighted") collabels("" "") prehead(@title "Dependent variable: Squared weighted residuals from 2nd stage regression" "")  ///
	prefoot("") postfoot("" "Notes:")


di ""
di "*************************************************************************************"
di ""

scalar dw1_t=string(Cdw1)
scalar dw2_t=string(Cdw2)
scalar dw3_t=string(Cdw3)
scalar dw4_t=string(Cdw4)
scalar dw_text = "Durbin-Watson statistics are "+ dw1_t+ ", "+dw2_t +", "+dw3_t +" and "+ dw4_t +", respectively."
scalar mss1_t=string(mssC1)
scalar mss2_t=string(mssC2)
scalar mss3_t=string(mssC3)
scalar mss4_t=string(mssC4)
scalar mss_text = "Model sum of squares statistics are "+ mss1_t+ ", "+mss2_t +", "+mss3_t +" and "+ mss4_t +", respectively."

estout C1 C2 C3 C4 C5, cells(b(star fmt(%9.6f)) se(par([ ])) ) starlevels(* 0.10 ** 0.05 *** 0.01) stats(r2 N, fmt(%9.3f %9.0g) ///
	labels("R-squared" "No. observations")) keep(d_ur s s_time s2 s_time2 _cons) legend label varlabels(_cons Constant) varwidth(18) ///
	modelwidth(11) delimiter("") title("Table 3a - `titulo' Cyclicality - 2nd stage (estimation: `abc') - unweighted") collabels("" "") prehead(@title "Dependent variable: `1'" "")  ///
	prefoot("") postfoot("" "Notes:")
di dw_text
di mss_text

estout C6, cells(b(star fmt(%9.6f)) se(par([ ])) ) starlevels(* 0.10 ** 0.05 *** 0.01) stats(r2 N, fmt(%9.3f %9.0g) ///
	labels("R-squared" "No. observations")) keep(inv _cons) legend label varlabels(_cons Constant) varwidth(18) ///
	modelwidth(11) delimiter("") title("Table 3b - Heteroskedasticity test 1 - unweighted") collabels("" "") prehead(@title "Dependent variable: Squared residuals from 2nd stage regression" "")  ///
	prefoot("") postfoot("" "Notes:")

estout C7, cells(b(star fmt(%9.6f)) se(par([ ])) ) starlevels(* 0.10 ** 0.05 *** 0.01) stats(r2 N, fmt(%9.3f %9.0g) ///
	labels("R-squared" "No. observations")) keep(sum_ports _cons) legend label varlabels(_cons Constant) varwidth(18) ///
	modelwidth(11) delimiter("") title("Table 3c - Heteroskedasticity test 2 - unweighted") collabels("" "") prehead(@title "Dependent variable: Squared weighted residuals from 2nd stage regression" "")  ///
	prefoot("") postfoot("" "Notes:")


qui log close

end


regrs_poes ln_rembaseh 3

regrs_poes ln_remh 3

